
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: No
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x045F
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	RCALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _dem=R4
	.DEF _dem_msb=R5

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_font:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x5F,0x0,0x0,0x0,0x0,0x7,0x0
	.DB  0x7,0x0,0x0,0x14,0x7F,0x14,0x7F,0x14
	.DB  0x0,0x24,0x2A,0x7F,0x2A,0x12,0x0,0x23
	.DB  0x13,0x8,0x64,0x62,0x0,0x36,0x49,0x55
	.DB  0x22,0x50,0x0,0x0,0x5,0x3,0x0,0x0
	.DB  0x0,0x0,0x1C,0x22,0x41,0x0,0x0,0x0
	.DB  0x41,0x22,0x1C,0x0,0x0,0x14,0x8,0x3E
	.DB  0x8,0x14,0x0,0x8,0x8,0x3E,0x8,0x8
	.DB  0x0,0x0,0x50,0x30,0x0,0x0,0x0,0x8
	.DB  0x8,0x8,0x8,0x8,0x0,0x0,0x60,0x60
	.DB  0x0,0x0,0x0,0x20,0x10,0x8,0x4,0x2
	.DB  0x0,0x3E,0x51,0x49,0x45,0x3E,0x0,0x0
	.DB  0x42,0x7F,0x40,0x0,0x0,0x42,0x61,0x51
	.DB  0x49,0x46,0x0,0x21,0x41,0x45,0x4B,0x31
	.DB  0x0,0x18,0x14,0x12,0x7F,0x10,0x0,0x27
	.DB  0x45,0x45,0x45,0x39,0x0,0x3C,0x4A,0x49
	.DB  0x49,0x30,0x0,0x1,0x71,0x9,0x5,0x3
	.DB  0x0,0x36,0x49,0x49,0x49,0x36,0x0,0x6
	.DB  0x49,0x49,0x29,0x1E,0x0,0x0,0x36,0x36
	.DB  0x0,0x0,0x0,0x0,0x56,0x36,0x0,0x0
	.DB  0x0,0x8,0x14,0x22,0x41,0x0,0x0,0x14
	.DB  0x14,0x14,0x14,0x14,0x0,0x0,0x41,0x22
	.DB  0x14,0x8,0x0,0x2,0x1,0x51,0x9,0x6
	.DB  0x0,0x32,0x49,0x79,0x41,0x3E,0x0,0x7E
	.DB  0x11,0x11,0x11,0x7E,0x0,0x7F,0x49,0x49
	.DB  0x49,0x36,0x0,0x3E,0x41,0x41,0x41,0x22
	.DB  0x0,0x7F,0x41,0x41,0x22,0x1C,0x0,0x7F
	.DB  0x49,0x49,0x49,0x41,0x0,0x7F,0x9,0x9
	.DB  0x9,0x1,0x0,0x3E,0x41,0x49,0x49,0x7A
	.DB  0x0,0x7F,0x8,0x8,0x8,0x7F,0x0,0x0
	.DB  0x41,0x7F,0x41,0x0,0x0,0x20,0x40,0x41
	.DB  0x3F,0x1,0x0,0x7F,0x8,0x14,0x22,0x41
	.DB  0x0,0x7F,0x40,0x40,0x40,0x40,0x0,0x7F
	.DB  0x2,0xC,0x2,0x7F,0x0,0x7F,0x4,0x8
	.DB  0x10,0x7F,0x0,0x3E,0x41,0x41,0x41,0x3E
	.DB  0x0,0x7F,0x9,0x9,0x9,0x6,0x0,0x3E
	.DB  0x41,0x51,0x21,0x5E,0x0,0x7F,0x9,0x19
	.DB  0x29,0x46,0x0,0x46,0x49,0x49,0x49,0x31
	.DB  0x0,0x1,0x1,0x7F,0x1,0x1,0x0,0x3F
	.DB  0x40,0x40,0x40,0x3F,0x0,0x1F,0x20,0x40
	.DB  0x20,0x1F,0x0,0x3F,0x40,0x38,0x40,0x3F
	.DB  0x0,0x63,0x14,0x8,0x14,0x63,0x0,0x7
	.DB  0x8,0x70,0x8,0x7,0x0,0x61,0x51,0x49
	.DB  0x45,0x43,0x0,0x0,0x7F,0x41,0x41,0x0
	.DB  0x0,0x2,0x4,0x8,0x10,0x20,0x0,0x0
	.DB  0x41,0x41,0x7F,0x0,0x0,0x4,0x2,0x1
	.DB  0x2,0x4,0x0,0x40,0x40,0x40,0x40,0x40
	.DB  0x0,0x0,0x1,0x2,0x4,0x0,0x0,0x20
	.DB  0x54,0x54,0x54,0x78,0x0,0x7F,0x48,0x44
	.DB  0x44,0x38,0x0,0x38,0x44,0x44,0x44,0x20
	.DB  0x0,0x38,0x44,0x44,0x48,0x7F,0x0,0x38
	.DB  0x54,0x54,0x54,0x18,0x0,0x8,0x7E,0x9
	.DB  0x1,0x2,0x0,0xC,0x52,0x52,0x52,0x3E
	.DB  0x0,0x7F,0x8,0x4,0x4,0x78,0x0,0x0
	.DB  0x44,0x7D,0x40,0x0,0x0,0x20,0x40,0x44
	.DB  0x3D,0x0,0x0,0x7F,0x10,0x28,0x44,0x0
	.DB  0x0,0x0,0x41,0x7F,0x40,0x0,0x0,0x7C
	.DB  0x4,0x18,0x4,0x78,0x0,0x7C,0x8,0x4
	.DB  0x4,0x78,0x0,0x38,0x44,0x44,0x44,0x38
	.DB  0x0,0x7C,0x14,0x14,0x14,0x8,0x0,0x8
	.DB  0x14,0x14,0x18,0x7C,0x0,0x7C,0x8,0x4
	.DB  0x4,0x8,0x0,0x48,0x54,0x54,0x54,0x20
	.DB  0x0,0x4,0x3F,0x44,0x40,0x20,0x0,0x3C
	.DB  0x40,0x40,0x20,0x7C,0x0,0x1C,0x20,0x40
	.DB  0x20,0x1C,0x0,0x3C,0x40,0x30,0x40,0x3C
	.DB  0x0,0x44,0x28,0x10,0x28,0x44,0x0,0xC
	.DB  0x50,0x50,0x50,0x3C,0x0,0x44,0x64,0x54
	.DB  0x4C,0x44,0x0,0x0,0x8,0x36,0x41,0x0
	.DB  0x0,0x0,0x0,0x7F,0x0,0x0,0x0,0x0
	.DB  0x41,0x36,0x8,0x0,0x0,0x10,0x8,0x8
	.DB  0x10,0x8,0x0,0x78,0x46,0x41,0x46,0x78

_0x0:
	.DB  0x54,0x65,0x73,0x74,0x20,0x47,0x72,0x61
	.DB  0x70,0x68,0x69,0x63,0x20,0x4C,0x43,0x44
	.DB  0x31,0x32,0x38,0x36,0x34,0x0,0x42,0x79
	.DB  0x20,0x56,0x75,0x20,0x54,0x68,0x61,0x69
	.DB  0x0,0x53,0x61,0x6E,0x67,0x54,0x61,0x6F
	.DB  0x43,0x6C,0x75,0x62,0x2E,0x4E,0x65,0x74
	.DB  0x0,0x4E,0x75,0x6D,0x3A,0x20,0x0

__GLOBAL_INI_TBL:
	.DW  0x16
	.DW  _0x33
	.DW  _0x0*2

	.DW  0x0B
	.DW  _0x33+22
	.DW  _0x0*2+22

	.DW  0x10
	.DW  _0x33+33
	.DW  _0x0*2+33

	.DW  0x06
	.DW  _0x33+49
	.DW  _0x0*2+49

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160

	.CSEG
;/****************************************************
;****Lap trinh giao tiep Graphic LCD 128x64 SPI (Gphone)****
;*******Code by Vu Van Thai - SangTaoClub.Net*********
;- Mot so lenh hien thi cho GLCD:
;    1. lcd_write(0,0xC8); //Hien thi nguoc, 0xC0 - Binh thuong
;    2. lcd_write(0,0xA7); //Hien thi am ban, 0xA6 - Binh thuong
;    3. lcd_write(0,0xA5); //Hien thi all pixel, 0xA4 - Binh thuong
;- Cac ham giao tiep GLCD:
;    1. lcd_init(); //Khoi tao GLCD
;    2. lcd_write(CD, DATA_BYTE);
;        //CD Select: 0 - Command, 1 - Display Data
;        //DATA_BYTE: Du lieu can ghi vao LCD
;    3. lcd_clear(); //Xoa man hinh
;    4. lcd_gotoxy(X, Y);
;        //X la vi tri hien thi 0-20 (Text font 5x7), Graphic 0-127
;        //Y la dong hien thi 0-7
;    5. lcd_putchar('Data_ASCII'); //Hien thi mot ky tu ASCII len man hinh
;    5. lcd_puts("String"); //Hien thi mot chuoi len man hinh
;****************************************************/
;#include <mega8.h> //Atmega 8 - Clock CPU 8Mhz
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;//Khai bao Port
;#define CS      PORTD.0 //Chon chip
;#define SDA     PORTD.1 //Data SPI
;#define AO      PORTD.2 //Chot du lieu Command va Data (C/D)
;#define SCK     PORTD.3 //Clock SPI
;flash unsigned char font[][6] ={    //Font 5x7
;   {0x00, 0x00, 0x00, 0x00, 0x00, 0x00} // 20
;  ,{0x00, 0x00, 0x00, 0x5f, 0x00, 0x00} // 21 !
;  ,{0x00, 0x00, 0x07, 0x00, 0x07, 0x00} // 22 "
;  ,{0x00, 0x14, 0x7f, 0x14, 0x7f, 0x14} // 23 #
;  ,{0x00, 0x24, 0x2a, 0x7f, 0x2a, 0x12} // 24 $
;  ,{0x00, 0x23, 0x13, 0x08, 0x64, 0x62} // 25 %
;  ,{0x00, 0x36, 0x49, 0x55, 0x22, 0x50} // 26 &
;  ,{0x00, 0x00, 0x05, 0x03, 0x00, 0x00} // 27 '
;  ,{0x00, 0x00, 0x1c, 0x22, 0x41, 0x00} // 28 (
;  ,{0x00, 0x00, 0x41, 0x22, 0x1c, 0x00} // 29 )
;  ,{0x00, 0x14, 0x08, 0x3e, 0x08, 0x14} // 2a *
;  ,{0x00, 0x08, 0x08, 0x3e, 0x08, 0x08} // 2b +
;  ,{0x00, 0x00, 0x50, 0x30, 0x00, 0x00} // 2c ,
;  ,{0x00, 0x08, 0x08, 0x08, 0x08, 0x08} // 2d -
;  ,{0x00, 0x00, 0x60, 0x60, 0x00, 0x00} // 2e .
;  ,{0x00, 0x20, 0x10, 0x08, 0x04, 0x02} // 2f /
;  ,{0x00, 0x3e, 0x51, 0x49, 0x45, 0x3e} // 30 0
;  ,{0x00, 0x00, 0x42, 0x7f, 0x40, 0x00} // 31 1
;  ,{0x00, 0x42, 0x61, 0x51, 0x49, 0x46} // 32 2
;  ,{0x00, 0x21, 0x41, 0x45, 0x4b, 0x31} // 33 3
;  ,{0x00, 0x18, 0x14, 0x12, 0x7f, 0x10} // 34 4
;  ,{0x00, 0x27, 0x45, 0x45, 0x45, 0x39} // 35 5
;  ,{0x00, 0x3c, 0x4a, 0x49, 0x49, 0x30} // 36 6
;  ,{0x00, 0x01, 0x71, 0x09, 0x05, 0x03} // 37 7
;  ,{0x00, 0x36, 0x49, 0x49, 0x49, 0x36} // 38 8
;  ,{0x00, 0x06, 0x49, 0x49, 0x29, 0x1e} // 39 9
;  ,{0x00, 0x00, 0x36, 0x36, 0x00, 0x00} // 3a :
;  ,{0x00, 0x00, 0x56, 0x36, 0x00, 0x00} // 3b ;
;  ,{0x00, 0x08, 0x14, 0x22, 0x41, 0x00} // 3c <
;  ,{0x00, 0x14, 0x14, 0x14, 0x14, 0x14} // 3d =
;  ,{0x00, 0x00, 0x41, 0x22, 0x14, 0x08} // 3e >
;  ,{0x00, 0x02, 0x01, 0x51, 0x09, 0x06} // 3f ?
;  ,{0x00, 0x32, 0x49, 0x79, 0x41, 0x3e} // 40 @
;  ,{0x00, 0x7e, 0x11, 0x11, 0x11, 0x7e} // 41 A
;  ,{0x00, 0x7f, 0x49, 0x49, 0x49, 0x36} // 42 B
;  ,{0x00, 0x3e, 0x41, 0x41, 0x41, 0x22} // 43 C
;  ,{0x00, 0x7f, 0x41, 0x41, 0x22, 0x1c} // 44 D
;  ,{0x00, 0x7f, 0x49, 0x49, 0x49, 0x41} // 45 E
;  ,{0x00, 0x7f, 0x09, 0x09, 0x09, 0x01} // 46 F
;  ,{0x00, 0x3e, 0x41, 0x49, 0x49, 0x7a} // 47 G
;  ,{0x00, 0x7f, 0x08, 0x08, 0x08, 0x7f} // 48 H
;  ,{0x00, 0x00, 0x41, 0x7f, 0x41, 0x00} // 49 I
;  ,{0x00, 0x20, 0x40, 0x41, 0x3f, 0x01} // 4a J
;  ,{0x00, 0x7f, 0x08, 0x14, 0x22, 0x41} // 4b K
;  ,{0x00, 0x7f, 0x40, 0x40, 0x40, 0x40} // 4c L
;  ,{0x00, 0x7f, 0x02, 0x0c, 0x02, 0x7f} // 4d M
;  ,{0x00, 0x7f, 0x04, 0x08, 0x10, 0x7f} // 4e N
;  ,{0x00, 0x3e, 0x41, 0x41, 0x41, 0x3e} // 4f O
;  ,{0x00, 0x7f, 0x09, 0x09, 0x09, 0x06} // 50 P
;  ,{0x00, 0x3e, 0x41, 0x51, 0x21, 0x5e} // 51 Q
;  ,{0x00, 0x7f, 0x09, 0x19, 0x29, 0x46} // 52 R
;  ,{0x00, 0x46, 0x49, 0x49, 0x49, 0x31} // 53 S
;  ,{0x00, 0x01, 0x01, 0x7f, 0x01, 0x01} // 54 T
;  ,{0x00, 0x3f, 0x40, 0x40, 0x40, 0x3f} // 55 U
;  ,{0x00, 0x1f, 0x20, 0x40, 0x20, 0x1f} // 56 V
;  ,{0x00, 0x3f, 0x40, 0x38, 0x40, 0x3f} // 57 W
;  ,{0x00, 0x63, 0x14, 0x08, 0x14, 0x63} // 58 X
;  ,{0x00, 0x07, 0x08, 0x70, 0x08, 0x07} // 59 Y
;  ,{0x00, 0x61, 0x51, 0x49, 0x45, 0x43} // 5a Z
;  ,{0x00, 0x00, 0x7f, 0x41, 0x41, 0x00} // 5b [
;  ,{0x00, 0x02, 0x04, 0x08, 0x10, 0x20} // 5c 
;  ,{0x00, 0x00, 0x41, 0x41, 0x7f, 0x00} // 5d ]
;  ,{0x00, 0x04, 0x02, 0x01, 0x02, 0x04} // 5e ^
;  ,{0x00, 0x40, 0x40, 0x40, 0x40, 0x40} // 5f _
;  ,{0x00, 0x00, 0x01, 0x02, 0x04, 0x00} // 60 `
;  ,{0x00, 0x20, 0x54, 0x54, 0x54, 0x78} // 61 a
;  ,{0x00, 0x7f, 0x48, 0x44, 0x44, 0x38} // 62 b
;  ,{0x00, 0x38, 0x44, 0x44, 0x44, 0x20} // 63 c
;  ,{0x00, 0x38, 0x44, 0x44, 0x48, 0x7f} // 64 d
;  ,{0x00, 0x38, 0x54, 0x54, 0x54, 0x18} // 65 e
;  ,{0x00, 0x08, 0x7e, 0x09, 0x01, 0x02} // 66 f
;  ,{0x00, 0x0c, 0x52, 0x52, 0x52, 0x3e} // 67 g
;  ,{0x00, 0x7f, 0x08, 0x04, 0x04, 0x78} // 68 h
;  ,{0x00, 0x00, 0x44, 0x7d, 0x40, 0x00} // 69 i
;  ,{0x00, 0x20, 0x40, 0x44, 0x3d, 0x00} // 6a j
;  ,{0x00, 0x7f, 0x10, 0x28, 0x44, 0x00} // 6b k
;  ,{0x00, 0x00, 0x41, 0x7f, 0x40, 0x00} // 6c l
;  ,{0x00, 0x7c, 0x04, 0x18, 0x04, 0x78} // 6d m
;  ,{0x00, 0x7c, 0x08, 0x04, 0x04, 0x78} // 6e n
;  ,{0x00, 0x38, 0x44, 0x44, 0x44, 0x38} // 6f o
;  ,{0x00, 0x7c, 0x14, 0x14, 0x14, 0x08} // 70 p
;  ,{0x00, 0x08, 0x14, 0x14, 0x18, 0x7c} // 71 q
;  ,{0x00, 0x7c, 0x08, 0x04, 0x04, 0x08} // 72 r
;  ,{0x00, 0x48, 0x54, 0x54, 0x54, 0x20} // 73 s
;  ,{0x00, 0x04, 0x3f, 0x44, 0x40, 0x20} // 74 t
;  ,{0x00, 0x3c, 0x40, 0x40, 0x20, 0x7c} // 75 u
;  ,{0x00, 0x1c, 0x20, 0x40, 0x20, 0x1c} // 76 v
;  ,{0x00, 0x3c, 0x40, 0x30, 0x40, 0x3c} // 77 w
;  ,{0x00, 0x44, 0x28, 0x10, 0x28, 0x44} // 78 x
;  ,{0x00, 0x0c, 0x50, 0x50, 0x50, 0x3c} // 79 y
;  ,{0x00, 0x44, 0x64, 0x54, 0x4c, 0x44} // 7a z
;  ,{0x00, 0x00, 0x08, 0x36, 0x41, 0x00} // 7b {
;  ,{0x00, 0x00, 0x00, 0x7f, 0x00, 0x00} // 7c |
;  ,{0x00, 0x00, 0x41, 0x36, 0x08, 0x00} // 7d }
;  ,{0x00, 0x10, 0x08, 0x08, 0x10, 0x08} // 7e ->
;  ,{0x00, 0x78, 0x46, 0x41, 0x46, 0x78} // 7f <-
;};
;void lcd_write(unsigned char cd, unsigned char byte){ //SPI 4Line
; 0000 007D void lcd_write(unsigned char cd, unsigned char byte){

	.CSEG
_lcd_write:
; .FSTART _lcd_write
; 0000 007E     unsigned char h;
; 0000 007F     CS=0;
	ST   -Y,R26
	ST   -Y,R17
;	cd -> Y+2
;	byte -> Y+1
;	h -> R17
	CBI  0x12,0
; 0000 0080     if(cd)AO=1;
	LDD  R30,Y+2
	CPI  R30,0
	BREQ _0x5
	SBI  0x12,2
; 0000 0081     else AO=0;
	RJMP _0x8
_0x5:
	CBI  0x12,2
; 0000 0082     for(h=0;h<8;h++){
_0x8:
	LDI  R17,LOW(0)
_0xC:
	CPI  R17,8
	BRSH _0xD
; 0000 0083         if(!(byte&0x80))SDA=0;
	LDD  R30,Y+1
	ANDI R30,LOW(0x80)
	BRNE _0xE
	CBI  0x12,1
; 0000 0084         else SDA=1;
	RJMP _0x11
_0xE:
	SBI  0x12,1
; 0000 0085         SCK=0;
_0x11:
	CBI  0x12,3
; 0000 0086         SCK=1;
	SBI  0x12,3
; 0000 0087         byte<<=1;
	LDD  R30,Y+1
	LSL  R30
	STD  Y+1,R30
; 0000 0088     }
	SUBI R17,-1
	RJMP _0xC
_0xD:
; 0000 0089     AO=~AO;
	SBIS 0x12,2
	RJMP _0x18
	CBI  0x12,2
	RJMP _0x19
_0x18:
	SBI  0x12,2
_0x19:
; 0000 008A     CS=1;
	SBI  0x12,0
; 0000 008B }
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
;void lcd_gotoxy(unsigned char x, unsigned char y){
; 0000 008C void lcd_gotoxy(unsigned char x, unsigned char y){
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
; 0000 008D     x=x*6;//Graphic Mode thi xoa dong nay di, Text thi de lai
	ST   -Y,R26
;	x -> Y+1
;	y -> Y+0
	LDD  R30,Y+1
	LDI  R26,LOW(6)
	MULS R30,R26
	MOVW R30,R0
	STD  Y+1,R30
; 0000 008E     lcd_write(0,(x&0x0f));
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDD  R30,Y+2
	ANDI R30,LOW(0xF)
	RCALL SUBOPT_0x0
; 0000 008F     lcd_write(0,((x>>4)&0x07)|0x10);
	LDD  R30,Y+2
	SWAP R30
	ANDI R30,LOW(0x7)
	ORI  R30,0x10
	RCALL SUBOPT_0x0
; 0000 0090     lcd_write(0,(y&0x0f)|0xb0);
	LDD  R30,Y+1
	ANDI R30,LOW(0xF)
	ORI  R30,LOW(0xB0)
	MOV  R26,R30
	RCALL _lcd_write
; 0000 0091 }
	RJMP _0x2000001
; .FEND
;void lcd_clear(void){
; 0000 0092 void lcd_clear(void){
_lcd_clear:
; .FSTART _lcd_clear
; 0000 0093     unsigned char u,w;
; 0000 0094     for(u=0;u<8;u++){
	RCALL __SAVELOCR2
;	u -> R17
;	w -> R16
	LDI  R17,LOW(0)
_0x1D:
	CPI  R17,8
	BRSH _0x1E
; 0000 0095         lcd_gotoxy(0,u);
	RCALL SUBOPT_0x1
	MOV  R26,R17
	RCALL _lcd_gotoxy
; 0000 0096         for(w=0;w<130;w++)
	LDI  R16,LOW(0)
_0x20:
	CPI  R16,130
	BRSH _0x21
; 0000 0097             lcd_write(1,0);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R26,LOW(0)
	RCALL _lcd_write
	SUBI R16,-1
	RJMP _0x20
_0x21:
; 0000 0098 }
	SUBI R17,-1
	RJMP _0x1D
_0x1E:
; 0000 0099     lcd_gotoxy(0,0);
	RCALL SUBOPT_0x1
	LDI  R26,LOW(0)
	RCALL _lcd_gotoxy
; 0000 009A }
	LD   R16,Y+
	LD   R17,Y+
	RET
; .FEND
;void lcd_putchar(char dat){
; 0000 009B void lcd_putchar(char dat){
_lcd_putchar:
; .FSTART _lcd_putchar
; 0000 009C     unsigned char v;
; 0000 009D     if((dat >= 0x20) && (dat <= 0x7f)){
	ST   -Y,R26
	ST   -Y,R17
;	dat -> Y+1
;	v -> R17
	LDD  R26,Y+1
	CPI  R26,LOW(0x20)
	BRLO _0x23
	CPI  R26,LOW(0x80)
	BRLO _0x24
_0x23:
	RJMP _0x22
_0x24:
; 0000 009E         dat=dat-32;
	LDD  R30,Y+1
	SUBI R30,LOW(32)
	STD  Y+1,R30
; 0000 009F         for(v=0;v<6;v++)
	LDI  R17,LOW(0)
_0x26:
	CPI  R17,6
	BRSH _0x27
; 0000 00A0             lcd_write(1, font[dat][v]);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+2
	LDI  R26,LOW(6)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_font*2)
	SBCI R31,HIGH(-_font*2)
	MOVW R26,R30
	MOV  R30,R17
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	LPM  R26,Z
	RCALL _lcd_write
	SUBI R17,-1
	RJMP _0x26
_0x27:
; 0000 00A1 }
; 0000 00A2 }
_0x22:
	LDD  R17,Y+0
	RJMP _0x2000001
; .FEND
;void lcd_puts(char *s){
; 0000 00A3 void lcd_puts(char *s){
_lcd_puts:
; .FSTART _lcd_puts
; 0000 00A4     while(*s)
	ST   -Y,R27
	ST   -Y,R26
;	*s -> Y+0
_0x28:
	LD   R26,Y
	LDD  R27,Y+1
	LD   R30,X
	CPI  R30,0
	BREQ _0x2A
; 0000 00A5         lcd_putchar(*s++);
	LD   R30,X+
	ST   Y,R26
	STD  Y+1,R27
	RCALL SUBOPT_0x2
	RJMP _0x28
_0x2A:
; 0000 00A6 }
_0x2000001:
	ADIW R28,2
	RET
; .FEND
;void lcd_init(void){//Khoi tao GLCD
; 0000 00A7 void lcd_init(void){
_lcd_init:
; .FSTART _lcd_init
; 0000 00A8     lcd_write(0,0xE2); //Reset
	RCALL SUBOPT_0x1
	LDI  R26,LOW(226)
	RCALL _lcd_write
; 0000 00A9     delay_ms(100);       //Delay 100ms
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 00AA     lcd_write(0,0xAF); //Display ON, 0xAE - OFF
	RCALL SUBOPT_0x1
	LDI  R26,LOW(175)
	RCALL _lcd_write
; 0000 00AB     lcd_write(0,0x2F); //Power control
	RCALL SUBOPT_0x1
	LDI  R26,LOW(47)
	RCALL _lcd_write
; 0000 00AC     lcd_clear(); //Xoa man hinh
	RCALL _lcd_clear
; 0000 00AD }
	RET
; .FEND
;unsigned int dem;
;void main(void){//Chuong trinh chinh
; 0000 00AF void main(void){
_main:
; .FSTART _main
; 0000 00B0     DDRD.0 = DDRD.1 = DDRD.2 = DDRD.3 = 1; //Port Output
	SBI  0x11,3
	SBI  0x11,2
	SBI  0x11,1
	SBI  0x11,0
; 0000 00B1     delay_ms(500);
	LDI  R26,LOW(500)
	LDI  R27,HIGH(500)
	RCALL _delay_ms
; 0000 00B2     lcd_init();
	RCALL _lcd_init
; 0000 00B3     delay_ms(100);
	LDI  R26,LOW(100)
	LDI  R27,0
	RCALL _delay_ms
; 0000 00B4     lcd_puts("Test Graphic LCD12864");
	__POINTW2MN _0x33,0
	RCALL _lcd_puts
; 0000 00B5     delay_ms(1000);
	LDI  R26,LOW(1000)
	LDI  R27,HIGH(1000)
	RCALL _delay_ms
; 0000 00B6     lcd_gotoxy(0,1);
	RCALL SUBOPT_0x1
	LDI  R26,LOW(1)
	RCALL _lcd_gotoxy
; 0000 00B7     lcd_puts("By Vu Thai");
	__POINTW2MN _0x33,22
	RCALL _lcd_puts
; 0000 00B8     lcd_gotoxy(0,3);
	RCALL SUBOPT_0x1
	LDI  R26,LOW(3)
	RCALL _lcd_gotoxy
; 0000 00B9     lcd_puts("SangTaoClub.Net");
	__POINTW2MN _0x33,33
	RCALL _lcd_puts
; 0000 00BA     lcd_gotoxy(0,6);
	RCALL SUBOPT_0x1
	LDI  R26,LOW(6)
	RCALL _lcd_gotoxy
; 0000 00BB     lcd_puts("Num: ");
	__POINTW2MN _0x33,49
	RCALL _lcd_puts
; 0000 00BC     delay_ms(2000);
	LDI  R26,LOW(2000)
	LDI  R27,HIGH(2000)
	RCALL _delay_ms
; 0000 00BD     while(1){
_0x34:
; 0000 00BE         lcd_gotoxy(5,6);
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R26,LOW(6)
	RCALL _lcd_gotoxy
; 0000 00BF         lcd_putchar((dem/1000)+48); //Ngan
	MOVW R26,R4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL SUBOPT_0x3
; 0000 00C0         lcd_putchar(((dem%1000)/100)+48); //Tram
	MOVW R26,R4
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x3
; 0000 00C1         lcd_putchar(((dem%100)/10)+48);  //Chuc
	MOVW R26,R4
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x3
; 0000 00C2         lcd_putchar((dem%10)+48);	//Don vi
	MOVW R26,R4
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __MODW21U
	SUBI R30,-LOW(48)
	RCALL SUBOPT_0x2
; 0000 00C3 		if(++dem>9999)dem=0;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
	CPI  R30,LOW(0x2710)
	LDI  R26,HIGH(0x2710)
	CPC  R31,R26
	BRLO _0x37
	CLR  R4
	CLR  R5
; 0000 00C4 		delay_ms(200);
_0x37:
	LDI  R26,LOW(200)
	LDI  R27,0
	RCALL _delay_ms
; 0000 00C5 	}
	RJMP _0x34
; 0000 00C6 }
_0x38:
	RJMP _0x38
; .FEND

	.DSEG
_0x33:
	.BYTE 0x37
;
;

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x0:
	MOV  R26,R30
	RCALL _lcd_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2:
	MOV  R26,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	RCALL __DIVW21U
	SUBI R30,-LOW(48)
	RJMP SUBOPT_0x2


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

;END OF CODE MARKER
__END_OF_CODE:
